---------------------------------------------------------------------------------------------------
-- Export plugin for SimTools V3
-- Version 1.0
-- Export start
---------------------------------------------------------------------------------------------------

Myfunction =

{
Start=function(self)
	package.path = package.path..";.\\LuaSocket\\?.lua"
	package.cpath = package.cpath..";.\\LuaSocket\\?.dll"
	socket = require("socket")

	my_init = socket.protect(function()
		-- export telemetry to SimTools
		host1 = host1 or "127.0.0.1"
		port1 = port1 or 41230
		c = socket.udp ( )
		c:settimeout ( 0 )
		c:setpeername ( host1, port1 )
--		c:send ( "Hello Wolrd!" )
--		c1 = socket.try(socket.connect(host1, port1)) -- connect to the listener socket
--		c1:setoption("tcp-nodelay",true) -- set immediate transmission mode
--		c1:settimeout(.01)
	end)
	my_init()
end,


AfterNextFrame=function(self)

	local altRad = LoGetAltitudeAboveGroundLevel()
	local pitch, bank, yaw = LoGetADIPitchBankYaw()
	local accel = LoGetAccelerationUnits()


	-- reduce forces on ground
	if altRad < 3 then
		accel.x = accel.x * 0.25
		accel.y = accel.y * 0.25
		accel.z = accel.z * 0.25
	end

	my_send = socket.protect(function()
		if c then
--			socket.try(c1:send(string.format("%.3f; %.3f; %.3f; %.3f; %.3f; %.3f;\n", pitch*1000.0, bank*1000.0, yaw*1000.0, accel.x*1000.0, accel.y*1000.0, accel.z*1000.0)))
			socket.try(c:send(string.format("%.4f; %.4f; %.4f; %.4f; %.4f; %.4f;\n", pitch, bank, yaw, accel.x, accel.y, accel.z)))

			end
	end)
	my_send()

end,


Stop=function(self)
	my_close = socket.protect(function()
		if c then
			c:close()
		end
	end)
	my_close()
end
}


-- =============
-- Overload
-- =============

-- Works once just before mission start.
do
	local PrevLuaExportStart=LuaExportStart
	LuaExportStart=function()
		Myfunction:Start()
		if PrevLuaExportStart then
			PrevLuaExportStart()
		end
	end
end

-- Works just after every simulation frame.
do
	local PrevLuaExportAfterNextFrame=LuaExportAfterNextFrame
	LuaExportAfterNextFrame=function()
		Myfunction:AfterNextFrame()
		if PrevLuaExportAfterNextFrame then
			PrevLuaExportAfterNextFrame()
		end
	end
end

-- Works once just after mission stop.
do
	local PrevLuaExportStop=LuaExportStop
	LuaExportStop=function()
		Myfunction:Stop()
		if PrevLuaExportStop then
			PrevLuaExportStop()
		end
	end
end
